/*
 * Harbor API
 *
 * These APIs provide services for manipulating Harbor project.
 *
 * OpenAPI spec version: 0.3.0
 *
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package apilib

type Repository struct {

	// Repository ID
	Id string `json:"id,omitempty"`

	// Parent of the image.
	Parent string `json:"parent,omitempty"`

	// Repository create time.
	Created string `json:"created,omitempty"`

	// Duration days of the image.
	DurationDays string `json:"duration_days,omitempty"`

	// Author of the image.
	Author string `json:"author,omitempty"`

	// Architecture of the image.
	Architecture string `json:"architecture,omitempty"`

	// Docker version of the image.
	DockerVersion string `json:"docker_version,omitempty"`

	// OS of the image.
	Os string `json:"os,omitempty"`
}

// Retag describes a retag request
type Retag struct {

	// The new tag
	Tag string `json:"tag"`

	// Source images in format <project>/<repo>:<reference>
	SrcImage string `json:"src_image"`

	// If target tag exists, whether override it
	Override bool `json:"override"`
}
