package cr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetRegionList invokes the cr.GetRegionList API synchronously
// api document: https://help.aliyun.com/api/cr/getregionlist.html
func (client *Client) GetRegionList(request *GetRegionListRequest) (response *GetRegionListResponse, err error) {
	response = CreateGetRegionListResponse()
	err = client.DoAction(request, response)
	return
}

// GetRegionListWithChan invokes the cr.GetRegionList API asynchronously
// api document: https://help.aliyun.com/api/cr/getregionlist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetRegionListWithChan(request *GetRegionListRequest) (<-chan *GetRegionListResponse, <-chan error) {
	responseChan := make(chan *GetRegionListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetRegionList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetRegionListWithCallback invokes the cr.GetRegionList API asynchronously
// api document: https://help.aliyun.com/api/cr/getregionlist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetRegionListWithCallback(request *GetRegionListRequest, callback func(response *GetRegionListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetRegionListResponse
		var err error
		defer close(result)
		response, err = client.GetRegionList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetRegionListRequest is the request struct for api GetRegionList
type GetRegionListRequest struct {
	*requests.RoaRequest
}

// GetRegionListResponse is the response struct for api GetRegionList
type GetRegionListResponse struct {
	*responses.BaseResponse
}

// CreateGetRegionListRequest creates a request to invoke GetRegionList API
func CreateGetRegionListRequest() (request *GetRegionListRequest) {
	request = &GetRegionListRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("cr", "2016-06-07", "GetRegionList", "/regions", "cr", "openAPI")
	request.Method = requests.GET
	return
}

// CreateGetRegionListResponse creates a response to parse from GetRegionList response
func CreateGetRegionListResponse() (response *GetRegionListResponse) {
	response = &GetRegionListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
