package cr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetRepoSourceRepo invokes the cr.GetRepoSourceRepo API synchronously
// api document: https://help.aliyun.com/api/cr/getreposourcerepo.html
func (client *Client) GetRepoSourceRepo(request *GetRepoSourceRepoRequest) (response *GetRepoSourceRepoResponse, err error) {
	response = CreateGetRepoSourceRepoResponse()
	err = client.DoAction(request, response)
	return
}

// GetRepoSourceRepoWithChan invokes the cr.GetRepoSourceRepo API asynchronously
// api document: https://help.aliyun.com/api/cr/getreposourcerepo.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetRepoSourceRepoWithChan(request *GetRepoSourceRepoRequest) (<-chan *GetRepoSourceRepoResponse, <-chan error) {
	responseChan := make(chan *GetRepoSourceRepoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetRepoSourceRepo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetRepoSourceRepoWithCallback invokes the cr.GetRepoSourceRepo API asynchronously
// api document: https://help.aliyun.com/api/cr/getreposourcerepo.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetRepoSourceRepoWithCallback(request *GetRepoSourceRepoRequest, callback func(response *GetRepoSourceRepoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetRepoSourceRepoResponse
		var err error
		defer close(result)
		response, err = client.GetRepoSourceRepo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetRepoSourceRepoRequest is the request struct for api GetRepoSourceRepo
type GetRepoSourceRepoRequest struct {
	*requests.RoaRequest
	RepoNamespace string `position:"Path" name:"RepoNamespace"`
	RepoName      string `position:"Path" name:"RepoName"`
}

// GetRepoSourceRepoResponse is the response struct for api GetRepoSourceRepo
type GetRepoSourceRepoResponse struct {
	*responses.BaseResponse
}

// CreateGetRepoSourceRepoRequest creates a request to invoke GetRepoSourceRepo API
func CreateGetRepoSourceRepoRequest() (request *GetRepoSourceRepoRequest) {
	request = &GetRepoSourceRepoRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("cr", "2016-06-07", "GetRepoSourceRepo", "/repos/[RepoNamespace]/[RepoName]/sourceRepo", "cr", "openAPI")
	request.Method = requests.GET
	return
}

// CreateGetRepoSourceRepoResponse creates a response to parse from GetRepoSourceRepo response
func CreateGetRepoSourceRepoResponse() (response *GetRepoSourceRepoResponse) {
	response = &GetRepoSourceRepoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
