package cr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetSubUserList invokes the cr.GetSubUserList API synchronously
// api document: https://help.aliyun.com/api/cr/getsubuserlist.html
func (client *Client) GetSubUserList(request *GetSubUserListRequest) (response *GetSubUserListResponse, err error) {
	response = CreateGetSubUserListResponse()
	err = client.DoAction(request, response)
	return
}

// GetSubUserListWithChan invokes the cr.GetSubUserList API asynchronously
// api document: https://help.aliyun.com/api/cr/getsubuserlist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetSubUserListWithChan(request *GetSubUserListRequest) (<-chan *GetSubUserListResponse, <-chan error) {
	responseChan := make(chan *GetSubUserListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetSubUserList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetSubUserListWithCallback invokes the cr.GetSubUserList API asynchronously
// api document: https://help.aliyun.com/api/cr/getsubuserlist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetSubUserListWithCallback(request *GetSubUserListRequest, callback func(response *GetSubUserListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetSubUserListResponse
		var err error
		defer close(result)
		response, err = client.GetSubUserList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetSubUserListRequest is the request struct for api GetSubUserList
type GetSubUserListRequest struct {
	*requests.RoaRequest
}

// GetSubUserListResponse is the response struct for api GetSubUserList
type GetSubUserListResponse struct {
	*responses.BaseResponse
}

// CreateGetSubUserListRequest creates a request to invoke GetSubUserList API
func CreateGetSubUserListRequest() (request *GetSubUserListRequest) {
	request = &GetSubUserListRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("cr", "2016-06-07", "GetSubUserList", "/users/subAccount", "cr", "openAPI")
	request.Method = requests.GET
	return
}

// CreateGetSubUserListResponse creates a response to parse from GetSubUserList response
func CreateGetSubUserListResponse() (response *GetSubUserListResponse) {
	response = &GetSubUserListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
